--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local addon, ns = ...
local cargBags = ns.cargBags

local InkedBags = cargBags:NewImplementation("InkedBags")	-- Let the magic begin!
local function RegisterBagsToBlizzard()
InkedBags:RegisterBlizzard()
end
function InkedBags:OnInit()
if Inked.db.profile.UseBags == false then  return end  
	-- The filters control which items go into which container
	local INVERTED = -1 -- with inverted filters (using -1), everything goes into this bag when the filter returns false

	local onlyBags =		function(item) return item.bagID >= 0 and item.bagID <= 4 end
	local onlyKeyring =		function(item) return item.bagID == -2 end
	local onlyBank =		function(item) return item.bagID == -1 or item.bagID >= 5 and item.bagID <= 11 end
	local onlyReagent = 	function(item) return item.bagID == -3 end
	local onlyRareEpics =	function(item) return item.rarity and item.rarity > 3 end
	local onlyEpics =		function(item) return item.rarity and item.rarity > 3 end
	
	local onlyCommon =			function(item) return item.rarity and item.rarity == 1 end
	local onlyUncommon =		function(item) return item.rarity and item.rarity == 2 end
	local onlySingleRare =		function(item) return item.rarity and item.rarity == 3 end
	local onlySingleEpics =		function(item) return item.rarity and item.rarity == 4 end
	local onlyLegendary =		function(item) return item.rarity and item.rarity == 5 end
	local onlyArtifact =		function(item) return item.rarity and item.rarity == 6 end
	local onlyLooms =			function(item) return item.rarity and item.rarity == 7 end
	
	
	local hideJunk =		function(item) return not item.rarity or item.rarity > 0 end
	local hideEmpty =		function(item) return item.texture ~= nil end
	local onlyConsumables = function(item) return item.type == Gem end
	
	local myConsumables = function(item) return item.type.Consumables end
	

	local MyContainer = self:GetContainerClass()


	-- Bagpack
	local main = MyContainer:New("Main", {
			Columns = 10,
			Scale = 1,
			Bags = "backpack+bags",
			
		})
		main:SetFilter(onlyBags, true) 
		--main:SetFilter(onlyRareEpics, false) 
		--main:SetFilter(onlyCommon, true)
		main:SetFilter(hideEmpty, false)
		main:SetFilter(onlyLooms, false)
	--	main:SetBags("backpack+bags")
		main:SetPoint("BOTTOMRIGHT", -25, 25)
		

	--Bank frame and bank bags
	local bank = MyContainer:New("Bank", {
			Columns = 26,
			Scale = 1,
			Bags = "bankframe+bank",
		})
		bank:SetFilter(onlyBank, true) -- Take only items from the bank frame
		--bank:SetFilter(hideEmpty, true)
		bank:SetPoint("LEFT", 25,-250) -- Place at left side of UI

	
		local Reagentz = MyContainer:New("Reagents", {
			Columns = 26,
			Scale = 1,
			Bags = "bankframe",
		})
		--Reagentz:SetFilter(onlyBank, true) -- Take only items from the bank frame
		Reagentz:SetFilter(onlyReagent, true)
		Reagentz:SetPoint("TOP",bank, 0,350) -- Place at left side of UI
		 -- Hide at the beginning
		 Reagentz:Hide()
		bank:Hide() -- Hide at the beginning
			
	
end


function InkedBags:OnBankOpened()
	self:GetContainer("Bank"):Show()
	if(IsReagentBankUnlocked()) then
	 self:GetContainer("Reagents"):Show()	
	 else
	 ReagentBankFrameUnlockInfoPurchaseButton:Click()
	 end	
	
	 -- SortBankBags()
	 -- SortReagentBankBags();
	 -- SetSortBagsRightToLeft(false)
	 -- SortBags();
end

function InkedBags:OnBankClosed()

	self:GetContainer("Bank"):Hide()
	self:GetContainer("Reagents"):Hide()
end
	local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")	
		InkedLoginFrame:RegisterEvent("BAG_UPDATE_COOLDOWN");		
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			if Inked.db.profile.UseBags == false then  
				return        
			end	  

			RegisterBagsToBlizzard()			
		end)